/************************************************************************
* EPP RTK C++
* Copyright (C) 2001 Global Name Registry
*
* This library is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
*
* This library is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* Contact information:  epprtk@gnr.com
*
*                       EPP RTK
*                       GNR Ltd.
*                       125 High Holborn
*                       London WC1V 6QA
*                       United Kingdom
************************************************************************/

#ifndef __DOM_PRINT_H
#define __DOM_PRINT_H

#include <string>
#include <iostream>

#include "dom_output.h"
#include "dom_wrapper.h"

namespace domtools {
   
   
   class DomPrint {
    private:
      //lint -e1725
      // out is a reference on purpose. Thus any constructors added should
      // _always_ initialize out from a reference passed in.
      basic_output & out;
      //lint +e1725
      
      bool ignorews;
      bool canIgnore;
      
      xml_string_output defaultOutput;
    public:
      DomPrint() : out(defaultOutput)
	{
	   reset();
	}

      DomPrint ( basic_output & inOut) : out(inOut)
	{
	   reset();
	}

      
      xml_string_output getDefaultOutput() const
	{
	   return defaultOutput;
	}
      

      void reset(void)
	{
	   ignorews = true;
	   canIgnore = true;
	}
      
      void putDOMTree(const domtools::dom_ptr);
      
      void setWhitespace(bool ignore)
	{
	   ignorews = ignore;
	}
   };
   
}

#endif
