/************************************************************************
* EPP RTK C++
* Copyright (C) 2001 Global Name Registry
*
* This library is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
*
* This library is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* Contact information:  epprtk@gnr.com
*
*                       EPP RTK
*                       GNR Ltd.
*                       125 High Holborn
*                       London WC1V 6QA
*                       United Kingdom
************************************************************************/

#ifndef __DOM_TOOLS_EXCEPTIONS
#define __DOM_TOOLS_EXCEPTIONS

#include <string>
#include <iostream>
#include <exception>
#include <cstdio>

namespace domtools {
   
   class Exception : public std::exception {
    private:
      std::string str;
    public:
      Exception()
	{
	}
      
      ~Exception() throw()
	{
	}
      
      Exception(const std::string & f, int lineno, const std::string & inStr)
	{
	   char buf[10];
	   sprintf(buf,"%d",lineno);
	   str = f;
	   str += ", line: ";
	   str += buf;
	   str += " ";
	   str += inStr;
	}
      
      virtual const char * what(void) const throw()
	{
	   return str.c_str();
	}
      
   };
}

#endif
